import { Component, ViewChild, AfterViewInit, ElementRef, ChangeDetectorRef } from '@angular/core';
import { NativeInputComponent } from '../../_abstract/native-input.component';
import { FriendlyValidationErrorsService } from './../../../services/friendly-validation-errors.service';

@Component({
	selector: 'app-clr-text',
	templateUrl: './clr-text.component.html',
	styleUrls: ['./clr-text.component.scss']
})
export class ClrTextComponent extends NativeInputComponent implements AfterViewInit {

	exposeMetaInTemplate: string[] = ['label', 'placeholder', 'link'];

	label: string;
	placeholder: string;
	link: string;

	readonly componentName = 'TextComponent'; // For AOT compatibility, as class names don't survive minification

	@ViewChild('input')
	formInput: ElementRef;

	constructor(
		protected valErrsService: FriendlyValidationErrorsService,
		protected _cdr: ChangeDetectorRef
	) {
		super(valErrsService, _cdr);
	}

	ngAfterViewInit() {
		(this.formInput.nativeElement as HTMLInputElement).setAttribute(`data-${this._meta.name.toLowerCase()}`, '');
	}

}
